#include "chdecl.h"
void CH_type_infer(current, sched, cop)
#define ARGUMENTS 10
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb4;
    case 2: goto c5;
    case 3: goto c35;
    case 4: goto cb38;
    case 5: goto c39;
    case 6: goto cb40;
    case 7: goto c41;
    case 8: goto c44;
    case 9: goto c55;
    case 10: goto cb67;
    case 11: goto c68;
    case 12: goto cb70;
    case 13: goto c71;
    case 14: goto cb73;
    case 15: goto c74;
    case 16: goto cb76;
    case 17: goto c77;
    case 18: goto cb79;
    case 19: goto c80;
    case 20: goto c82;
    case 21: goto c83;
    case 22: goto cb84;
    case 23: goto c85;
    case 24: goto c111;
    case 25: goto c124;
    case 26: goto c126;
    case 27: goto c137;
    case 28: goto c140;
    case 29: goto c142;
    case 30: goto c146;
    case 31: goto c147;
    case 32: goto c149;
    case 33: goto c151;
    case 34: goto c165;
    case 35: goto c176;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
/* new_inport 3 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).value = ch_val; REF(3).tsdr = & dr_inport;
/* connect 4 3 */
  if (REF(3).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(3).value.inport->refcount++;
  REF(4).value.outport = REF(3).value.inport;
  REF(4).tsdr = & dr_outport;
  current->ip = 1;
cb4:
/* receive 5 0 */
  if ((ch_returncode = che_receive(DEF(5),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c5:
/* prog_lit 6 , 2 */
  if ((ch_returncode = che_prog_lit(DEF(6),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 7 6 , 3 */
  if ((ch_returncode = che_procedure(DEF(7),DEF(6),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* discard 6 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).tsdr = & dr_bottom;
/* move 8 7 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8) = REF(7);
  REF(7).tsdr = & dr_bottom;
/* prog_lit 9 , 4 */
  if ((ch_returncode = che_prog_lit(DEF(9),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 10 9 , 3 */
  if ((ch_returncode = che_procedure(DEF(10),DEF(9),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* discard 9 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).tsdr = & dr_bottom;
/* move 11 10 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11) = REF(10);
  REF(10).tsdr = & dr_bottom;
/* prog_lit 12 , 5 */
  if ((ch_returncode = che_prog_lit(DEF(12),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 13 12 , 3 */
  if ((ch_returncode = che_procedure(DEF(13),DEF(12),QUAL(3)
    ,sched)) != Normal) goto ch_raise_exception;
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
/* move 14 13 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14) = REF(13);
  REF(13).tsdr = & dr_bottom;
/* prog_lit 15 , 6 */
  if ((ch_returncode = che_prog_lit(DEF(15),QUAL(6),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 16 15 , 3 */
  if ((ch_returncode = che_procedure(DEF(16),DEF(15),QUAL(3)
    ,sched)) != Normal) goto ch_raise_exception;
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
/* move 17 16 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17) = REF(16);
  REF(16).tsdr = & dr_bottom;
/* prog_lit 18 , 7 */
  if ((ch_returncode = che_prog_lit(DEF(18),QUAL(7),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 19 18 , 3 */
  if ((ch_returncode = che_procedure(DEF(19),DEF(18),QUAL(3)
    ,sched)) != Normal) goto ch_raise_exception;
/* discard 18 */
  (*(REF(18).tsdr)->finalize)(REF(18).value,F_DISCARD,sched);
  REF(18).tsdr = & dr_bottom;
/* move 20 19 */
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20) = REF(19);
  REF(19).tsdr = & dr_bottom;
/* copy 21 5.0 */
  if((ch_returncode = cp_outport(& ch_val, REF(5)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).value = ch_val;
  REF(21).tsdr = & dr_outport;
/* copy 22 5.1 */
  if((ch_returncode = (REF(5)DOT(1).tsdr->copy)(& ch_val, REF(5)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).value = ch_val;
  REF(22).tsdr = datarepmap[REF(5)DOT(1).tsdr->number];
/* copy 23 5.2 */
  if((ch_returncode = (REF(5)DOT(2).tsdr->copy)(& ch_val, REF(5)DOT(2).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  REF(23).value = ch_val;
  REF(23).tsdr = datarepmap[REF(5)DOT(2).tsdr->number];
/* move 5.3 4 */
  (*(REF(5)DOT(3).tsdr)->finalize)(REF(5)DOT(3).value,F_DISCARD,sched);
  REF(5)DOT(3) = REF(4);
  REF(4).tsdr = & dr_bottom;
/* return 5 */
  if (ch_caller = do_return(REF(5).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(5).value);
  REF(5).tsdr = & dr_bottom;
/* discard 0 */
  (*(REF(0).tsdr)->finalize)(REF(0).value,F_DISCARD,sched);
  REF(0).tsdr = & dr_bottom;
/* new_record 24 , 3 */
  if ((ch_val.record = new_record(3)) == nil) goto ch_depletion;
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).value = ch_val; REF(24).tsdr = & dr_record;
/* ordenum_lit 24.1 , 2 */
  REF(24)DOT(1).value.ord_enum = 2;
  REF(24)DOT(1).tsdr = & dr_ord_enumeration;
/* new_table 24.2 , 8 */
  if ((ch_returncode = che_new_table(DEF(24)DOT(2),QUAL(8),sched)) != Normal) 
     goto ch_raise_exception;
c35:
/* noop */
  
/* block , 9 */
  if((ch_returncode = che_block(QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 4;
cb38:
/* receive 25 3 */
  if ((ch_returncode = che_receive(DEF(25),DEF(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c39:
/* block , 10 */
  if((ch_returncode = che_block(QUAL(10),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 6;
cb40:
/* call 21 25.2 22.1.0 23 25.3 26 , 11 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(21),
          arguments[1] = DEF(25)DOT(2),
          arguments[2] = DEF(22)DOT(1)DOT(0),
          arguments[3] = DEF(23),
          arguments[4] = DEF(25)DOT(3),
          arguments[5] = DEF(26),
          arguments[5+1] = nil,& arguments[0]),QUAL(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c41:
/* move 27 26 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27) = REF(26);
  REF(26).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 55 */
   goto c55;
c44:
/* new_record 28 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  REF(28).value = ch_val; REF(28).tsdr = & dr_record;
/* copy 28.0 25.2.0 */
  if((ch_returncode = (REF(25)DOT(2)DOT(0).tsdr->copy)(& ch_val, 
    REF(25)DOT(2)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(28)DOT(0).tsdr)->finalize)(REF(28)DOT(0).value,F_DISCARD,sched);
  REF(28)DOT(0).value = ch_val;
  REF(28)DOT(0).tsdr = datarepmap[REF(25)DOT(2)DOT(0).tsdr->number];
/* new_record 29 , 4 */
  if ((ch_val.record = new_record(4)) == nil) goto ch_depletion;
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  REF(29).value = ch_val; REF(29).tsdr = & dr_record;
/* copy 29.0 25.0 */
  REF(29)DOT(0) = REF(25)DOT(0);
/* copy 29.1 25.1 */
  if((ch_returncode = (REF(25)DOT(1).tsdr->copy)(& ch_val, REF(25)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(1).tsdr)->finalize)(REF(29)DOT(1).value,F_DISCARD,sched);
  REF(29)DOT(1).value = ch_val;
  REF(29)DOT(1).tsdr = datarepmap[REF(25)DOT(1).tsdr->number];
/* copy 29.2 25.2 */
  if((ch_returncode = (REF(25)DOT(2).tsdr->copy)(& ch_val, REF(25)DOT(2).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(2).tsdr)->finalize)(REF(29)DOT(2).value,F_DISCARD,sched);
  REF(29)DOT(2).value = ch_val;
  REF(29)DOT(2).tsdr = datarepmap[REF(25)DOT(2).tsdr->number];
/* copy 29.3 25.7 */
  if((ch_returncode = (REF(25)DOT(7).tsdr->copy)(& ch_val, REF(25)DOT(7).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(3).tsdr)->finalize)(REF(29)DOT(3).value,F_DISCARD,sched);
  REF(29)DOT(3).value = ch_val;
  REF(29)DOT(3).tsdr = datarepmap[REF(25)DOT(7).tsdr->number];
/* unite 28.1 29 , 1 */
  if ((ch_returncode = che_unite(DEF(28)DOT(1),DEF(29),sched,1)) != Normal)
     goto ch_raise_exception;
/* insert 25.5 28 */
  if ((ch_returncode = insertfunc(DEF(25)DOT(5),DEF(28),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* exit , 12 */
  ch_e = handler_type__exit; ch_val = QUAL(12); goto ch_exception;
c55:
/* noop */
  
/* equal . 25.0 =(4) , 67 */
  if ( REF(25)DOT(0).value.enumeration == 4 ) goto c67;
/* equal . 25.0 =(3) , 70 */
  if ( REF(25)DOT(0).value.enumeration == 3 ) goto c70;
/* equal . 25.0 =(2) , 73 */
  if ( REF(25)DOT(0).value.enumeration == 2 ) goto c73;
/* equal . 25.0 =(1) , 76 */
  if ( REF(25)DOT(0).value.enumeration == 1 ) goto c76;
/* equal . 25.0 =(0) , 79 */
  if ( REF(25)DOT(0).value.enumeration == 0 ) goto c79;
/* branch , 82 */
   goto c82;
c67:
  current->ip = 10;
cb67:
/* call 20 27 23 30 , 13 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(20),
          arguments[1] = DEF(27),
          arguments[2] = DEF(23),
          arguments[3] = DEF(30),
          arguments[3+1] = nil,& arguments[0]),QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  return;
c68:
/* move 31 30 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31) = REF(30);
  REF(30).tsdr = & dr_bottom;
/* branch , 83 */
   goto c83;
c70:
  current->ip = 12;
cb70:
/* call 17 27 23 32 , 13 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(17),
          arguments[1] = DEF(27),
          arguments[2] = DEF(23),
          arguments[3] = DEF(32),
          arguments[3+1] = nil,& arguments[0]),QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  return;
c71:
/* move 31 32 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31) = REF(32);
  REF(32).tsdr = & dr_bottom;
/* branch , 83 */
   goto c83;
c73:
  current->ip = 14;
cb73:
/* call 14 27 23 33 , 13 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(14),
          arguments[1] = DEF(27),
          arguments[2] = DEF(23),
          arguments[3] = DEF(33),
          arguments[3+1] = nil,& arguments[0]),QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  return;
c74:
/* move 31 33 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31) = REF(33);
  REF(33).tsdr = & dr_bottom;
/* branch , 83 */
   goto c83;
c76:
  current->ip = 16;
cb76:
/* call 11 27 23 34 , 13 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(11),
          arguments[1] = DEF(27),
          arguments[2] = DEF(23),
          arguments[3] = DEF(34),
          arguments[3+1] = nil,& arguments[0]),QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  return;
c77:
/* move 31 34 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31) = REF(34);
  REF(34).tsdr = & dr_bottom;
/* branch , 83 */
   goto c83;
c79:
  current->ip = 18;
cb79:
/* call 8 27 23 35 , 13 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(8),
          arguments[1] = DEF(27),
          arguments[2] = DEF(23),
          arguments[3] = DEF(35),
          arguments[3+1] = nil,& arguments[0]),QUAL(13),sched)) != Normal)
     goto ch_raise_exception;
  return;
c80:
/* move 31 35 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31) = REF(35);
  REF(35).tsdr = & dr_bottom;
/* branch , 83 */
   goto c83;
c82:
/* exit , 14 */
  ch_e = handler_type__exit; ch_val = QUAL(14); goto ch_exception;
c83:
/* block , 15 */
  if((ch_returncode = che_block(QUAL(15),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 22;
cb84:
/* call 21 25.1 22.1.0 23 25.3 36 , 11 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(21),
          arguments[1] = DEF(25)DOT(1),
          arguments[2] = DEF(22)DOT(1)DOT(0),
          arguments[3] = DEF(23),
          arguments[4] = DEF(25)DOT(3),
          arguments[5] = DEF(36),
          arguments[5+1] = nil,& arguments[0]),QUAL(11),sched)) != Normal)
     goto ch_raise_exception;
  return;
c85:
/* noop */
  
/* equal . 36 31 , 107 */
  if ( (REF(36).tsdr->equal)(REF(36).value,REF(31).value) ) goto c107;
/* copy 37 24 */
  if((ch_returncode = cp_record(& ch_val, REF(24).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(37).tsdr)->finalize)(REF(37).value,F_DISCARD,sched);
  REF(37).value = ch_val;
  REF(37).tsdr = & dr_record;
/* copy 38 25.7 */
  if((ch_returncode = (REF(25)DOT(7).tsdr->copy)(& ch_val, REF(25)DOT(7).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(38).tsdr)->finalize)(REF(38).value,F_DISCARD,sched);
  REF(38).value = ch_val;
  REF(38).tsdr = datarepmap[REF(25)DOT(7).tsdr->number];
/* unite 37.0 38 , 0 */
  if ((ch_returncode = che_unite(DEF(37)DOT(0),DEF(38),sched,0)) != Normal)
     goto ch_raise_exception;
/* copy 39 25.1 */
  if((ch_returncode = (REF(25)DOT(1).tsdr->copy)(& ch_val, REF(25)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(39).tsdr)->finalize)(REF(39).value,F_DISCARD,sched);
  REF(39).value = ch_val;
  REF(39).tsdr = datarepmap[REF(25)DOT(1).tsdr->number];
/* unite 40 39 , 0 */
  if ((ch_returncode = che_unite(DEF(40),DEF(39),sched,0)) != Normal)
     goto ch_raise_exception;
/* insert 37.2 40 */
  if ((ch_returncode = insertfunc(DEF(37)DOT(2),DEF(40),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* unite 40 36 , 2 */
  if ((ch_returncode = che_unite(DEF(40),DEF(36),sched,2)) != Normal)
     goto ch_raise_exception;
/* insert 37.2 40 */
  if ((ch_returncode = insertfunc(DEF(37)DOT(2),DEF(40),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* copy 41 25.2 */
  if((ch_returncode = (REF(25)DOT(2).tsdr->copy)(& ch_val, REF(25)DOT(2).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(41).tsdr)->finalize)(REF(41).value,F_DISCARD,sched);
  REF(41).value = ch_val;
  REF(41).tsdr = datarepmap[REF(25)DOT(2).tsdr->number];
/* unite 40 41 , 0 */
  if ((ch_returncode = che_unite(DEF(40),DEF(41),sched,0)) != Normal)
     goto ch_raise_exception;
/* insert 37.2 40 */
  if ((ch_returncode = insertfunc(DEF(37)DOT(2),DEF(40),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* unite 40 31 , 2 */
  if ((ch_returncode = che_unite(DEF(40),DEF(31),sched,2)) != Normal)
     goto ch_raise_exception;
/* insert 37.2 40 */
  if ((ch_returncode = insertfunc(DEF(37)DOT(2),DEF(40),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 25.6 37 */
  if ((ch_returncode = insertfunc(DEF(25)DOT(6),DEF(37),FALSE,0)) != Normal)
     goto ch_raise_exception;
c107:
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
/* discard 36 */
  (*(REF(36).tsdr)->finalize)(REF(36).value,F_DISCARD,sched);
  REF(36).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 137 */
   goto c137;
c111:
/* size 42 25.1.1 */
  REF(42).value.integer = REF(25)DOT(1)DOT(1).value.table->size;
  REF(42).tsdr = & dr_integer;
/* notequal . 42 =(0) , 126 */
  if ( REF(42).value.integer != 0 ) goto c126;
/* new_record 43 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(43).tsdr)->finalize)(REF(43).value,F_DISCARD,sched);
  REF(43).value = ch_val; REF(43).tsdr = & dr_record;
/* copy 43.0 25.1.0 */
  if((ch_returncode = (REF(25)DOT(1)DOT(0).tsdr->copy)(& ch_val, 
    REF(25)DOT(1)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(43)DOT(0).tsdr)->finalize)(REF(43)DOT(0).value,F_DISCARD,sched);
  REF(43)DOT(0).value = ch_val;
  REF(43)DOT(0).tsdr = datarepmap[REF(25)DOT(1)DOT(0).tsdr->number];
/* move 43.1 31 */
  (*(REF(43)DOT(1).tsdr)->finalize)(REF(43)DOT(1).value,F_DISCARD,sched);
  REF(43)DOT(1) = REF(31);
  REF(31).tsdr = & dr_bottom;
/* insert 25.3 43 */
  if ((ch_returncode = insertfunc(DEF(25)DOT(3),DEF(43),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* block , 16 */
  if((ch_returncode = che_block(QUAL(16),sched)) != Normal)
     goto ch_raise_exception;
/* copy 44 25.1.0 */
  if((ch_returncode = (REF(25)DOT(1)DOT(0).tsdr->copy)(& ch_val, 
    REF(25)DOT(1)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(44).tsdr)->finalize)(REF(44).value,F_DISCARD,sched);
  REF(44).value = ch_val;
  REF(44).tsdr = datarepmap[REF(25)DOT(1)DOT(0).tsdr->number];
/* insert 25.4 44 */
  if ((ch_returncode = insertfunc(DEF(25)DOT(4),DEF(44),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
c124:
/* discard 44 */
  (*(REF(44).tsdr)->finalize)(REF(44).value,F_DISCARD,sched);
  REF(44).tsdr = & dr_bottom;
/* branch , 137 */
   goto c137;
c126:
/* new_record 28 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  REF(28).value = ch_val; REF(28).tsdr = & dr_record;
/* copy 28.0 25.1.0 */
  if((ch_returncode = (REF(25)DOT(1)DOT(0).tsdr->copy)(& ch_val, 
    REF(25)DOT(1)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(28)DOT(0).tsdr)->finalize)(REF(28)DOT(0).value,F_DISCARD,sched);
  REF(28)DOT(0).value = ch_val;
  REF(28)DOT(0).tsdr = datarepmap[REF(25)DOT(1)DOT(0).tsdr->number];
/* new_record 29 , 4 */
  if ((ch_val.record = new_record(4)) == nil) goto ch_depletion;
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  REF(29).value = ch_val; REF(29).tsdr = & dr_record;
/* copy 29.0 25.0 */
  REF(29)DOT(0) = REF(25)DOT(0);
/* copy 29.1 25.1 */
  if((ch_returncode = (REF(25)DOT(1).tsdr->copy)(& ch_val, REF(25)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(1).tsdr)->finalize)(REF(29)DOT(1).value,F_DISCARD,sched);
  REF(29)DOT(1).value = ch_val;
  REF(29)DOT(1).tsdr = datarepmap[REF(25)DOT(1).tsdr->number];
/* copy 29.2 25.2 */
  if((ch_returncode = (REF(25)DOT(2).tsdr->copy)(& ch_val, REF(25)DOT(2).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(2).tsdr)->finalize)(REF(29)DOT(2).value,F_DISCARD,sched);
  REF(29)DOT(2).value = ch_val;
  REF(29)DOT(2).tsdr = datarepmap[REF(25)DOT(2).tsdr->number];
/* copy 29.3 25.7 */
  if((ch_returncode = (REF(25)DOT(7).tsdr->copy)(& ch_val, REF(25)DOT(7).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29)DOT(3).tsdr)->finalize)(REF(29)DOT(3).value,F_DISCARD,sched);
  REF(29)DOT(3).value = ch_val;
  REF(29)DOT(3).tsdr = datarepmap[REF(25)DOT(7).tsdr->number];
/* unite 28.1 29 , 1 */
  if ((ch_returncode = che_unite(DEF(28)DOT(1),DEF(29),sched,1)) != Normal)
     goto ch_raise_exception;
/* insert 25.5 28 */
  if ((ch_returncode = insertfunc(DEF(25)DOT(5),DEF(28),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* exit , 12 */
  ch_e = handler_type__exit; ch_val = QUAL(12); goto ch_exception;
c137:
/* return 25 */
  if (ch_caller = do_return(REF(25).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(25).value);
  REF(25).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 147 */
   goto c147;
c140:
/* return 25 */
  if (ch_caller = do_return(REF(25).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(25).value);
  REF(25).tsdr = & dr_bottom;
/* branch , 147 */
   goto c147;
c142:
/* discard 27 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).tsdr = & dr_bottom;
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
/* return 25 */
  if (ch_caller = do_return(REF(25).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(25).value);
  REF(25).tsdr = & dr_bottom;
/* branch , 147 */
   goto c147;
c146:
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
c147:
/* discard 27 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).tsdr = & dr_bottom;
/* branch , 35 */
   goto c35;
c149:
/* endblock */
  che_endblock(sched);
/* branch , 165 */
   goto c165;
c151:
/* discard 0 */
  (*(REF(0).tsdr)->finalize)(REF(0).value,F_DISCARD,sched);
  REF(0).tsdr = & dr_bottom;
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* discard 17 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).tsdr = & dr_bottom;
/* discard 20 */
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).tsdr = & dr_bottom;
/* discard 21 */
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).tsdr = & dr_bottom;
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* discard 23 */
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  REF(23).tsdr = & dr_bottom;
/* discard 24 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).tsdr = & dr_bottom;
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
/* discard 27 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).tsdr = & dr_bottom;
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
c165:
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* discard 17 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).tsdr = & dr_bottom;
/* discard 20 */
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).tsdr = & dr_bottom;
/* discard 21 */
  (*(REF(21).tsdr)->finalize)(REF(21).value,F_DISCARD,sched);
  REF(21).tsdr = & dr_bottom;
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* discard 23 */
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  REF(23).tsdr = & dr_bottom;
/* discard 24 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c176:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
